//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
USERES("MainDemo.res");
USEFORM("MainDemo_Unit.cpp", Form1);
USEFORM("_Ab120Meter.cpp", Ab120MeterForm);
USEFORM("_Ab180Meter.cpp", Ab180MeterForm);
USEFORM("_Ab270Meter.cpp", Ab270MeterForm);
USEFORM("_AbBar.cpp", AbBarForm);
USEFORM("_AbBevel.cpp", AbBevelForm);
USEFORM("_AbClock.cpp", AbClockForm);
USEFORM("_AbCompass.cpp", AbCompassForm);
USEFORM("_AbDial.cpp", AbDialForm);
USEFORM("_AbGearDial.cpp", AbGearDialForm);
USEFORM("_AbGradient.cpp", AbGradientForm);
USEFORM("_AbHBar.cpp", AbHBarForm);
USEFORM("_AbHMeter.cpp", AbHMeterForm);
USEFORM("_AbHSlider.cpp", AbHSliderForm);
USEFORM("_AbLED.cpp", AbLEDForm);
USEFORM("_AbMiniTrend.cpp", AbMiniTrendForm);
USEFORM("_AbNumEdit.cpp", AbNumEditForm);
USEFORM("_AbNumSpin.cpp", AbNumSpinForm);
USEFORM("_AbOperatingPoint.cpp", AbOperatingPointForm);
USEFORM("_AbPanel.cpp", AbPanelForm);
USEFORM("_AbTrend.cpp", AbTrendForm);
USEFORM("_AbPrintTrend.cpp", AbPrintTrendForm);
USEFORM("_AbSpinBtn.cpp", AbSpinBtnForm);
USEFORM("_AbTank.cpp", AbTankForm);
USEFORM("_AbThermometer.cpp", AbThermometerForm);
USEFORM("_AbTimerSpeedBtn.cpp", AbTimerSpeedBtnForm);
USEFORM("_AbValueInd.cpp", AbValueIndForm);
USEFORM("_AbVBar.cpp", AbVBarForm);
USEFORM("_AbVCInd.cpp", AbVCIndForm);
USEFORM("_AbVMeter.cpp", AbVMeterForm);
USEFORM("_AbVSlider.cpp", AbVSliderForm);
USEFORM("AnalogIndEvents.cpp", AnalogIndEventsForm);
USEFORM("DialSliderEvents.cpp", Dial_SilderEventsForm);
USEFORM("_AbColBitBtn.cpp", AbColBitBtnForm);
USEFORM("_AbLabel.cpp", AbLabelForm);
USEFORM("_AbOpHourCounter.cpp", AbOpHourCounterForm);
USEFORM("_AbRockerSwitch.cpp", AbRockerSwitchForm);
USEFORM("_AbToggleSwitch.cpp", AbToggleSwitchForm);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    try
    {
        Application->Initialize();
        Application->CreateForm(__classid(TForm1), &Form1);
        Application->CreateForm(__classid(TAb120MeterForm), &Ab120MeterForm);
        Application->CreateForm(__classid(TAb180MeterForm), &Ab180MeterForm);
        Application->CreateForm(__classid(TAb270MeterForm), &Ab270MeterForm);
        Application->CreateForm(__classid(TAbBarForm), &AbBarForm);
        Application->CreateForm(__classid(TAbBevelForm), &AbBevelForm);
        Application->CreateForm(__classid(TAbClockForm), &AbClockForm);
        Application->CreateForm(__classid(TAbCompassForm), &AbCompassForm);
        Application->CreateForm(__classid(TAbDialForm), &AbDialForm);
        Application->CreateForm(__classid(TAbGearDialForm), &AbGearDialForm);
        Application->CreateForm(__classid(TAbGradientForm), &AbGradientForm);
        Application->CreateForm(__classid(TAbHBarForm), &AbHBarForm);
        Application->CreateForm(__classid(TAbHMeterForm), &AbHMeterForm);
        Application->CreateForm(__classid(TAbHSliderForm), &AbHSliderForm);
        Application->CreateForm(__classid(TAbLEDForm), &AbLEDForm);
        Application->CreateForm(__classid(TAbMiniTrendForm), &AbMiniTrendForm);
        Application->CreateForm(__classid(TAbNumEditForm), &AbNumEditForm);
        Application->CreateForm(__classid(TAbNumSpinForm), &AbNumSpinForm);
        Application->CreateForm(__classid(TAbOperatingPointForm), &AbOperatingPointForm);
        Application->CreateForm(__classid(TAbPanelForm), &AbPanelForm);
        Application->CreateForm(__classid(TAbTrendForm), &AbTrendForm);
        Application->CreateForm(__classid(TAbPrintTrendForm), &AbPrintTrendForm);
        Application->CreateForm(__classid(TAbSpinBtnForm), &AbSpinBtnForm);
        Application->CreateForm(__classid(TAbTankForm), &AbTankForm);
        Application->CreateForm(__classid(TAbThermometerForm), &AbThermometerForm);
        Application->CreateForm(__classid(TAbTimerSpeedBtnForm), &AbTimerSpeedBtnForm);
        Application->CreateForm(__classid(TAbValueIndForm), &AbValueIndForm);
        Application->CreateForm(__classid(TAbVBarForm), &AbVBarForm);
        Application->CreateForm(__classid(TAbVCIndForm), &AbVCIndForm);
        Application->CreateForm(__classid(TAbVMeterForm), &AbVMeterForm);
        Application->CreateForm(__classid(TAbVSliderForm), &AbVSliderForm);
        Application->CreateForm(__classid(TAnalogIndEventsForm), &AnalogIndEventsForm);
        Application->CreateForm(__classid(TDial_SilderEventsForm), &Dial_SilderEventsForm);
        Application->CreateForm(__classid(TAbColBitBtnForm), &AbColBitBtnForm);
        Application->CreateForm(__classid(TAbLabelForm), &AbLabelForm);
        Application->CreateForm(__classid(TAbOpHourCounterForm), &AbOpHourCounterForm);
        Application->CreateForm(__classid(TAbRockerSwitchForm), &AbRockerSwitchForm);
        Application->CreateForm(__classid(TAbToggleSwitchForm), &AbToggleSwitchForm);
        Application->Run();
    }
    catch (Exception &exception)
    {
        Application->ShowException(&exception);
    }
    return 0;
}
//---------------------------------------------------------------------------
