unit _AbTrend;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AbTrend, AbMTrend, AbVSlide, StdCtrls, Spin, AbVInd,
  AbFlashT, Buttons, ExtCtrls, _GClass, AbNumEdit;

type
  TAbTrendForm = class(TForm)
    AbTrend1: TAbTrend;
    Panel1: TPanel;
    Label8: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    AbValueInd1: TAbValueInd;
    AbValueInd2: TAbValueInd;
    AbValueInd3: TAbValueInd;
    AbValueInd4: TAbValueInd;
    AbValueInd5: TAbValueInd;
    AbValueInd6: TAbValueInd;
    AbValueInd7: TAbValueInd;
    AbValueInd8: TAbValueInd;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Bevel2: TBevel;
    Label9: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    Panel2: TPanel;
    JumpRevBtn: TSpeedButton;
    BigJumpRevBtn: TSpeedButton;
    BigJumpFwdBtn: TSpeedButton;
    JumpFwdBtn: TSpeedButton;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    CheckBox1: TCheckBox;
    StartRecCheckbox: TCheckBox;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    PrintBtn: TSpeedButton;
    LoadBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    DeleteBtn: TSpeedButton;
    Label16: TLabel;
    Label17: TLabel;
    FastBtn: TSpeedButton;
    SpinLeftScale: TAbNumSpin;
    SpinAbsScale: TAbNumSpin;
    FillChSpin: TAbNumSpin;
    Label18: TLabel;
    SpinGridSteps: TAbNumSpin;
    LeftScaleVisibleCB: TCheckBox;
    AbsScaleCB: TCheckBox;
    Ch7UpperLimitCB: TCheckBox;
    Ch8LowerLimitCB: TCheckBox;
    DateCB: TCheckBox;
    TimeCB: TCheckBox;
    Bevel5: TBevel;
    procedure CheckBox1Click(Sender: TObject);
    procedure AbTrend1NewCursorPos(Sender: TObject);
    procedure JumpRevBtnClick(Sender: TObject);
    procedure JumpFwdBtnClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure BigJumpRevBtnClick(Sender: TObject);
    procedure BigJumpFwdBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StartRecCheckboxClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure AbTrend1RecNoChanged(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure FastBtnClick(Sender: TObject);
    procedure FillChSpinChange(Sender: TObject);
    procedure SpinAbsScaleChange(Sender: TObject);
    procedure SpinLeftScaleChange(Sender: TObject);
    procedure SpinGridStepsValueChanged(Sender: TObject);
    procedure LeftScaleVisibleCBClick(Sender: TObject);
    procedure AbsScaleCBClick(Sender: TObject);
    procedure Ch7UpperLimitCBClick(Sender: TObject);
    procedure Ch8LowerLimitCBClick(Sender: TObject);
    procedure DateCBClick(Sender: TObject);
    procedure TimeCBClick(Sender: TObject);
  private
    { Private-Deklarationen }
  protected
     procedure WMFlash(var Message: TMessage);message WM_FLASH;
  public
    { Public-Deklarationen }
  end;

var
  AbTrendForm: TAbTrendForm;
  Dummy1 : Smallint;
  Dummy2 : Smallint;
  Dummy3 : Smallint;
  Dummy4 : Smallint;
  Dummy5 : Smallint;
  Dummy6 : Smallint;
  Dummy7 : Smallint;
  Dummy8 : Smallint;
  ExePath : String;

implementation
uses _AbPrintTrend;

{$R *.DFM}


procedure TAbTrendForm.WMFlash(var Message: TMessage);
begin
   {used to calc. some values}
   if (csDesigning in componentstate) then exit;
   with message do begin
      Dummy1 := Dummy1+1;
      if Dummy1 > 100 then begin
         Dummy1 := 0;
         if AbTrend1.Channel8.Digit = 900 then
           AbTrend1.Channel8.Digit := 800
         else AbTrend1.Channel8.Digit := 900;
      end;

      Dummy2 := Dummy2 +1 ;
      if Dummy2 >= 9000 then begin
         Dummy2 := 0;
      end;

      Dummy3 := Dummy3 +1 ;
      if Dummy3 >= 9000 then begin
         Dummy3 := 0;
      end;

      Dummy4 := Dummy4 +1 ;
      if Dummy4 >= 9000 then Dummy4 := 0;

      Dummy5 := Dummy5 +Dummy6 ;
      if Dummy5 >= 9000 then Dummy6 := -10
      else if Dummy5 <= 0  then Dummy6 := 10;


      AbTrend1.Channel1.Value := 20+sin(Dummy4/100);
      AbTrend1.Channel2.Value := 4+ Sin(Dummy3/100);
      AbTrend1.Channel3.Value := Sin(Dummy2/100)*3.12;
      AbTrend1.Channel4.Value := 20+Sin(Dummy3/100);
      AbTrend1.Channel5.Digit := Dummy1;
      AbTrend1.Channel6.Value := 5+Dummy5/1800;
      AbTrend1.Channel7.Value := 13+Random(30)/10;
   end;
end;

procedure TAbTrendForm.CheckBox1Click(Sender: TObject);
begin
   AbTrend1.flow := CheckBox1.checked;
end;

procedure TAbTrendForm.AbTrend1NewCursorPos(Sender: TObject);
begin
  if AbTrend1.ValueAtCursor.DataValid then begin
     AbValueInd1.Value := AbTrend1.ValueAtCursor.ValueCh1;
     AbValueInd2.Value := AbTrend1.ValueAtCursor.ValueCh2;
     AbValueInd3.Value := AbTrend1.ValueAtCursor.ValueCh3;
     AbValueInd4.Value := AbTrend1.ValueAtCursor.ValueCh4;
     AbValueInd5.Value := AbTrend1.ValueAtCursor.ValueCh5;
     AbValueInd6.Value := AbTrend1.ValueAtCursor.ValueCh6;
     AbValueInd7.Value := AbTrend1.ValueAtCursor.ValueCh7;
     AbValueInd8.Value := AbTrend1.ValueAtCursor.ValueCh8;
     Label7.caption := IntToStr(AbTrend1.ValueAtCursor.RecordNo);
     Label4.caption := DateTimeToStr(AbTrend1.ValueAtCursor.Time);
  end else begin
     AbValueInd1.Value := 0;
     AbValueInd2.Value := 0;
     AbValueInd3.Value := 0;
     AbValueInd4.Value := 0;
     AbValueInd5.Value := 0;
     AbValueInd6.Value := 0;
     AbValueInd7.Value := 0;
     AbValueInd8.Value := 0;
     Label7.caption := 'not Valid';
     Label4.caption := '-----'
  end;

end;

procedure TAbTrendForm.JumpRevBtnClick(Sender: TObject);
begin
  AbTrend1.MoveX(-AbTrend1.GridXPixel);
  Checkbox1.checked := false; {flow = off}
end;

procedure TAbTrendForm.JumpFwdBtnClick(Sender: TObject);
begin
  AbTrend1.MoveX(AbTrend1.GridXPixel);
  Checkbox1.checked := false; {flow = off}
end;

procedure TAbTrendForm.SpeedButton1Click(Sender: TObject);
begin
  AbTrend1.MoveY(10);
end;

procedure TAbTrendForm.SpeedButton5Click(Sender: TObject);
begin
  AbTrend1.MoveY(- 10);
end;

procedure TAbTrendForm.SpeedButton3Click(Sender: TObject);
begin
  AbTrend1.SetYDefault;
end;

procedure TAbTrendForm.SpeedButton2Click(Sender: TObject);
begin
   AbTrend1.ZoomYIn;
end;

procedure TAbTrendForm.SpeedButton4Click(Sender: TObject);
begin
   AbTrend1.ZoomYOut;
end;

procedure TAbTrendForm.CheckBox2Click(Sender: TObject);
begin
   AbTrend1.Channel1.Visible := CheckBox2.Checked;
end;

procedure TAbTrendForm.CheckBox3Click(Sender: TObject);
begin
   AbTrend1.Channel2.Visible := CheckBox3.Checked;

end;

procedure TAbTrendForm.CheckBox4Click(Sender: TObject);
begin
   AbTrend1.Channel3.Visible := CheckBox4.Checked;

end;

procedure TAbTrendForm.CheckBox5Click(Sender: TObject);
begin
   AbTrend1.Channel4.Visible := CheckBox5.Checked;

end;

procedure TAbTrendForm.CheckBox6Click(Sender: TObject);
begin
   AbTrend1.Channel5.Visible := CheckBox6.Checked;

end;

procedure TAbTrendForm.CheckBox7Click(Sender: TObject);
begin
   AbTrend1.Channel6.Visible := CheckBox7.Checked;

end;

procedure TAbTrendForm.CheckBox8Click(Sender: TObject);
begin
   AbTrend1.Channel7.Visible := CheckBox8.Checked;

end;

procedure TAbTrendForm.CheckBox9Click(Sender: TObject);
begin
   AbTrend1.Channel8.Visible := CheckBox9.Checked;

end;

procedure TAbTrendForm.BigJumpRevBtnClick(Sender: TObject);
begin
  AbTrend1.MoveX(-AbTrend1.GridXPixel*4);
  Checkbox1.checked := false; {flow = off}
end;

procedure TAbTrendForm.BigJumpFwdBtnClick(Sender: TObject);
begin
  AbTrend1.MoveX(AbTrend1.GridXPixel*4);
  Checkbox1.checked := false; {flow = off}
end;

procedure TAbTrendForm.FormCreate(Sender: TObject);
begin
  ExePath := ExtractFileDir(ParamStr(0)) + '\';

  Dummy1 := 0;
  Dummy2 := 0;
  Dummy3 := 225;
  Dummy4 := 675;
  Dummy5 := 458;
  Dummy6 := 10;
  Dummy7 := 0;
  Dummy8 := 0;
  AddControl(self,100); {100ms interval}

end;

procedure TAbTrendForm.StartRecCheckboxClick(Sender: TObject);
begin
   AbTrend1.StartRecording := StartRecCheckbox.checked;
   FastBtn.Enabled := StartRecCheckbox.checked; {only enabled if StartRecording}
end;

procedure TAbTrendForm.FormDestroy(Sender: TObject);
begin
   DelControl(self);
end;

procedure TAbTrendForm.AbTrend1RecNoChanged(Sender: TObject);
begin
  Label11.caption := IntToStr(AbTrend1.RecordInfo.TotalRecords);
  Label14.caption := DateTimeToStr(AbTrend1.RecordInfo.FirstRecord);
  Label15.caption := DateTimeToStr(AbTrend1.RecordInfo.LastRecord);
end;

procedure TAbTrendForm.PrintBtnClick(Sender: TObject);
var
  frm : TForm;
begin
    try
       Frm := TAbPrintTrendForm.create(Application);
       with Frm do begin
          if ShowModal = mrOK then begin

          end;
       end;
    finally
       Frm.free;
    end;
end;

procedure TAbTrendForm.DeleteBtnClick(Sender: TObject);
begin
   AbTrend1.ClearRecords;
end;

procedure TAbTrendForm.LoadBtnClick(Sender: TObject);
var
   err : integer;
begin
  err := AbTrend1.LoadFromFile(ExePath + 'test.trd');
  {err = FileIO error code, ok if 0}

  Checkbox1.checked := false; {flow = off}
  StartRecCheckbox.checked := false; {StartRecording = false}
end;

procedure TAbTrendForm.SaveBtnClick(Sender: TObject);
var
   err : integer;
begin
  err := AbTrend1.SaveToFile(ExePath + 'test.trd');
  {err = FileIO error code, ok if 0}

  Checkbox1.checked := false; {flow = off}
end;

procedure TAbTrendForm.FastBtnClick(Sender: TObject);
begin
   AbTrend1.RunInterval2(300); {300 records with interval 2}
end;

procedure TAbTrendForm.FillChSpinChange(Sender: TObject);
begin
   AbTrend1.FillChannelNo := FillChSpin.ValueAsInt;
end;

procedure TAbTrendForm.SpinAbsScaleChange(Sender: TObject);
begin
  AbTrend1.AbsScaleCh := SpinAbsScale.ValueAsInt;
end;

procedure TAbTrendForm.SpinLeftScaleChange(Sender: TObject);
begin
  AbTrend1.LeftScaleCh := SpinLeftScale.ValueAsInt;
end;

procedure TAbTrendForm.SpinGridStepsValueChanged(Sender: TObject);
begin
  AbTrend1.GridYSteps := SpinGridSteps.ValueAsInt;
end;

procedure TAbTrendForm.LeftScaleVisibleCBClick(Sender: TObject);
begin
  if LeftScaleVisibleCB.checked then
    AbTrend1.Options := AbTrend1.Options + [opLeftScale]
  else
    AbTrend1.Options := AbTrend1.Options - [opLeftScale] ;
end;

procedure TAbTrendForm.AbsScaleCBClick(Sender: TObject);
begin
  if AbsScaleCB.checked then
    AbTrend1.Options := AbTrend1.Options + [opRightScale]
  else
    AbTrend1.Options := AbTrend1.Options - [opRightScale] ;
end;

procedure TAbTrendForm.Ch7UpperLimitCBClick(Sender: TObject);
begin
  if Ch7UpperLimitCB.checked then
    AbTrend1.Options := AbTrend1.Options + [opCh7isUL]
  else
    AbTrend1.Options := AbTrend1.Options - [opCh7isUL] ;
end;

procedure TAbTrendForm.Ch8LowerLimitCBClick(Sender: TObject);
begin
  if Ch8LowerLimitCB.checked then
    AbTrend1.Options := AbTrend1.Options + [opCh8isLL]
  else
    AbTrend1.Options := AbTrend1.Options - [opCh8isLL] ;
end;

procedure TAbTrendForm.DateCBClick(Sender: TObject);
begin
  if DateCB.checked then
    AbTrend1.Options := AbTrend1.Options + [opDate]
  else
    AbTrend1.Options := AbTrend1.Options - [opDate] ;
end;

procedure TAbTrendForm.TimeCBClick(Sender: TObject);
begin
  if TimeCB.checked then
    AbTrend1.Options := AbTrend1.Options + [opTime]
  else
    AbTrend1.Options := AbTrend1.Options - [opTime] ;
end;

end.
