unit MainDemo_Unit;

interface

uses
  Windows,
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AbClock, Menus, ExtCtrls, Buttons, ShellAPI,

  _GClass, AbGradient,

  // Misc
  _AbClock, _AbOpHourCounter, _AbBevel, _AbPanel, _AbGradient, _AbTimerSpeedBtn,
  _AbSpinBtn, _AbNumEdit, _AbNumSpin, 

  // Binary
  _AbLED, _AbLabel, _AbColBitBtn, _AbRockerSwich, _AbToggleSwitch,

  // Analog Indicators
  _AbBar,_AbHBar,_AbVBar,_AbThermometer,         // Bar Indicators
  _AbHMeter,_AbVMeter,                         // Meters
  _Ab120Meter,_Ab180Meter,_Ab270Meter,          // round meters
  _AbTank, _AbValueInd, _AbOperatingPoint,
  _AbCompass, _AbVCInd,
  AnalogIndEvents,

  // Sliders + Dials
  _AbHSlider,_AbVSlider,_AbDial,_AbGearDial,
  DialSliderEvents,

  // Trends
  _AbMiniTrend, _AbPrintTrend, _AbTrend, ComCtrls, Tabnotbk;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Components1: TMenuItem;
    TAbClock1: TMenuItem;
    Barindicators1: TMenuItem;
    TAbBar1: TMenuItem;
    TAbHBar1: TMenuItem;
    TAbVBar1: TMenuItem;
    TAbTank1: TMenuItem;
    Meters1: TMenuItem;
    TAbHMeter1: TMenuItem;
    TAbVMeter1: TMenuItem;
    TAb120Meter1: TMenuItem;
    TAb180Meter1: TMenuItem;
    TAb270Meter1: TMenuItem;
    TAbMiniTrend1: TMenuItem;
    TAbOperatingPoint1: TMenuItem;
    TAbDial1: TMenuItem;
    Sliders1: TMenuItem;
    TAbHSlider1: TMenuItem;
    TAbVSlider1: TMenuItem;
    TAbValueInd1: TMenuItem;
    Memo3: TMemo;
    Image1: TImage;
    Label17: TLabel;
    Label18: TLabel;
    Panel1: TPanel;
    Label3: TLabel;
    HintCheckBox: TCheckBox;
    Events1: TMenuItem;
    Analogindicators1: TMenuItem;
    DialSlider1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    TAbCompass1: TMenuItem;
    AbClock1: TAbClock;
    AbGradient1: TAbGradient;
    Label4: TLabel;
    Label5: TLabel;
    ComponentBar: TTabbedNotebook;

    AbClockBtn: TSpeedButton;
    AbOpHourCounterBtn: TSpeedButton;
    AbLabelBtn: TSpeedButton;
    AbValueIndBtn: TSpeedButton;
    AbBarBtn: TSpeedButton;
    AbVBarBtn: TSpeedButton;
    AbHBarBtn: TSpeedButton;
    AbTankBtn: TSpeedButton;
    AbThermometerBtn: TSpeedButton;
    AbVMeterBtn: TSpeedButton;
    AbHMeterBtn: TSpeedButton;
    Ab120MeterBtn: TSpeedButton;
    Ab180MeterBtn: TSpeedButton;
    Ab270MeterBtn: TSpeedButton;
    AbCompassBtn: TSpeedButton;
    AbOperatingPointBtn: TSpeedButton;
    AbMiniTrendBtn: TSpeedButton;
    AbTrendBtn: TSpeedButton;
    AbPrintTrendBtn: TSpeedButton;
    AbDialBtn: TSpeedButton;
    AbHSliderBtn: TSpeedButton;
    AbVSliderBtn: TSpeedButton;
    AbGearDialBtn: TSpeedButton;
    AbLEDBtn: TSpeedButton;
    AbColBitBtnBtn: TSpeedButton;
    AbRockerSwichBtn: TSpeedButton;
    AbToggleSwitchBtn: TSpeedButton;
    TAbGearDial1: TMenuItem;
    Dials1: TMenuItem;
    Binary1: TMenuItem;
    TAbLED1: TMenuItem;
    TAbColBitBtn1: TMenuItem;
    TAbRockerSwitch1: TMenuItem;
    TAbToggleSwitch1: TMenuItem;
    Label6: TLabel;
    Image2: TImage;
    AbBevelBtn: TSpeedButton;
    AbPanelBtn: TSpeedButton;
    AbGradientBtn: TSpeedButton;
    AbTimerSpeedBtn: TSpeedButton;
    AbSpinBtn: TSpeedButton;
    AbNumEditBtn: TSpeedButton;
    AbNumSpinBtn: TSpeedButton;
    AbVCIndBtn: TSpeedButton;

    procedure ComponentBtnClick(Sender: TObject);
    procedure Analogindicators1Click(Sender: TObject);
    procedure DialSlider1Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;
  Frm : TForm;

implementation


{$R *.DFM}

procedure DemoLoop;
begin
    try
       with Frm do begin
          if ShowModal = mrOK then begin

          end;
       end;
    finally
       Frm.free;
       Frm := nil;
    end;
end;

procedure TForm1.ComponentBtnClick(Sender: TObject);
var
  cName : String;
begin
  if (sender is TSpeedButton)
    then cName := (sender as TSpeedButton).Hint
  else if (sender is TMenuItem)
    then cName := (sender as TMenuItem).Hint
  else exit;

  // AbMisc - Tab
  if cName = 'TAbClock' then
    Frm := TAbClockForm.create(Application)
  else if cName = 'TAbOpHourCounter' then
    Frm := TTAbOpHourCounterForm.create(Application)
  else if cName = 'TAbLabel' then
    Frm := TTAbLabelForm.create(Application)
  else if cName = 'TAbBevel' then
    Frm := TAbBevelForm.create(Application)
  else if cName = 'TAbPanel' then
    Frm := TAbPanelForm.create(Application)
  else if cName = 'TAbGradient' then
    Frm := TAbGradientForm.create(Application)
  else if cName = 'TAbTimerSpeedBtn' then
    Frm := TAbTimerSpeedBtnForm.create(Application)
  else if cName = 'TAbSpinButton' then
    Frm := TAbSpinBtnForm.create(Application)
  else if cName = 'TAbNumEdit' then
    Frm := TAbNumEditForm.create(Application)
  else if cName = 'TAbNumSpin' then
    Frm := TAbNumSpinForm.create(Application)


  // AbAnalogInd - Tab
  else if cName = 'TAbValueInd' then
    Frm := TAbValueIndForm.create(Application)
  else if cName = 'TAbBar' then
    Frm := TAbBarForm.create(Application)
  else if cName = 'TAbVBar' then
    Frm := TAbVBarForm.create(Application)
  else if cName = 'TAbHBar' then
    Frm := TAbHBarForm.create(Application)
  else if cName = 'TAbTank' then
    Frm := TAbTankForm.create(Application)
  else if cName = 'TAbThermometer' then
    Frm := TAbThermometerForm.create(Application)
  else if cName = 'TAbVMeter' then
    Frm := TAbVMeterForm.create(Application)
  else if cName = 'TAbHMeter' then
    Frm := TAbHMeterForm.create(Application)
  else if cName = 'TAb120Meter' then
    Frm := TAb120MeterForm.create(Application)
  else if cName = 'TAb180Meter' then
    Frm := TAb180MeterForm.create(Application)
  else if cName = 'TAb270Meter' then
    Frm := TAb270MeterForm.create(Application)
  else if cName = 'TAbCompass' then
    Frm := TAbCompassForm.create(Application)
  else if cName = 'TAbVCInd' then
    Frm := TAbVCIndForm.create(Application)
  else if cName = 'TAbOperatingPoint' then
    Frm := TAbOperatingPointForm.create(Application)
  else if cName = 'TAbMiniTrend' then
    Frm := TAbMiniTrendForm.create(Application)
  else if cName = 'TAbTrend' then
    AbTrendForm.Show
  else if cName = 'TAbPrintTrend' then
    Frm := TAbPrintTrendForm.create(Application)

  // AbAnalogAdj - Tab
  else if cName = 'TAbDial' then
    Frm := TAbDialForm.create(Application)
  else if cName = 'TAbGearDial' then
    Frm := TAbGearDialForm.create(Application)
  else if cName = 'TAbHSlider' then
    Frm := TAbHSliderForm.create(Application)
  else if cName = 'TAbVSlider' then
    Frm := TAbVSliderForm.create(Application)

  // AbBinary - Tab
  else if cName = 'TAbLED' then
    Frm := TAbLEDForm.create(Application)
  else if cName = 'TAbColBitBtn' then
    Frm := TTAbColBitBtnForm.create(Application)
  else if cName = 'TAbRockerSwich' then
    Frm := TTAbRockerSwichForm.create(Application)
  else if cName = 'TAbToggleSwitch' then
    Frm := TTAbToggleSwitchForm.create(Application);


  if frm = nil then exit;
  frm.ShowHint := HintCheckBox.Checked;

  // demo loop until Form "Frm" closed
  DemoLoop;

end;


procedure TForm1.Analogindicators1Click(Sender: TObject);
begin
   Frm := TAnalogIndEventsForm.create(Application);
   DemoLoop;
end;

procedure TForm1.DialSlider1Click(Sender: TObject);
begin
   Frm := TDial_SliderEventsForm.create(Application);
   DemoLoop;
end;

procedure TForm1.Label1Click(Sender: TObject);
var
  MailStr : String;
begin
  MailStr := 'MailTo:'+Label1.caption;
     ShellExecute(Self.Handle,nil,PChar(MailStr),nil,nil,0);
end;

procedure TForm1.Label2Click(Sender: TObject);
var
  WebStr: String;
begin
  if (sender is TLabel) then
    WebStr := (sender as TLabel).caption
  else exit;

  ShellExecute(Self.Handle,nil,PChar(WebStr),nil,nil,0);
end;


end.
