unit _AbGradient;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, _GClass, AbGradient, StdCtrls;

type
  TAbGradientForm = class(TForm)
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    AbGradient1: TAbGradient;
    AbGradient2: TAbGradient;
    AbGradient3: TAbGradient;
    AbGradient4: TAbGradient;
    AbGradient5: TAbGradient;
    AbGradient6: TAbGradient;
    AbGradient7: TAbGradient;
    AbGradient8: TAbGradient;
    AbGradient9: TAbGradient;
    AbGradient10: TAbGradient;
    AbGradient11: TAbGradient;
    AbGradient12: TAbGradient;
    AbGradient13: TAbGradient;
    ColorDialog1: TColorDialog;
    ColorFromBtn: TSpeedButton;
    ColorToBtn: TSpeedButton;
    ColorFromShape: TShape;
    ColorToShape: TShape;
    procedure ColorFromBtnClick(Sender: TObject);
    procedure ColorToBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure SetGradientColors;
  public
    { Public-Deklarationen }
  end;

var
  AbGradientForm: TAbGradientForm;

implementation

{$R *.DFM}

procedure TAbGradientForm.SetGradientColors;
var
  n   : Integer;
  cmp : TComponent;
begin
  // change colors for all TAbGradient components
  for n := 0 to ComponentCount-1 do begin
    cmp := Components[n];
    if (cmp is TAbGradient) then
      with (cmp as TAbGradient) do begin
        BeginUpdate;
        GradSettings.ColorFrom := ColorFromShape.Brush.Color;
        GradSettings.ColorTo   := ColorToShape.Brush.Color;
        EndUpdate;
      end;
  end;
end;

procedure TAbGradientForm.ColorFromBtnClick(Sender: TObject);
begin
  ColorDialog1.Color :=  ColorFromShape.Brush.Color;
  if ColorDialog1.Execute then
     ColorFromShape.Brush.Color := ColorDialog1.Color;
  SetGradientColors;
end;

procedure TAbGradientForm.ColorToBtnClick(Sender: TObject);
begin
  ColorDialog1.Color :=  ColorToShape.Brush.Color;
  if ColorDialog1.Execute then
     ColorToShape.Brush.Color := ColorDialog1.Color;
  SetGradientColors;
end;

end.
